#include "LedControl.h" 
#include <MD_DS3231.h>

//specify the LED matrices
   //display 0 is hours
   //display 1 is minutes
   //display 2 is seconds
   // pin 5 is connected to the MAX7219 pin 1
   // pin 4 is connected to the CLK pin 13
   // pin 3 is connected to LOAD pin 12

LedControl lc = LedControl(5, 4, 3, 3);

void setup() {

	randomSeed(analogRead(0));                     //seed the random number function

	//initialize the three  LEDs

	lc.shutdown(0, false);// turn off power saving, enables display
	lc.setIntensity(0, 5);// sets brightness (0~15 possible values)
	lc.clearDisplay(0);// clear screen

	lc.shutdown(1, false);// turn off power saving, enables display
	lc.setIntensity(1, 5);// sets brightness (0~15 possible values)
	lc.clearDisplay(1);// clear screen

	lc.shutdown(2, false);// turn off power saving, enables display
	lc.setIntensity(2, 5);// sets brightness (0~15 possible values)
	lc.clearDisplay(2);// clear screen


	Serial.begin(115200);
	
		// if we need to set the clock

		/*RTC.yyyy = 2019;    
		RTC.mm = 12;
		RTC.dd = 21;
		RTC.h = 13;
		RTC.m = 56;
		RTC.s = 0;

		RTC.writeTime();
		delay(1000); */

		RTC.readTime();
		Serial.print(RTC.h);
		Serial.print(":");
		Serial.print(RTC.m);
		Serial.print(":");
		Serial.println(RTC.s);
}

void loop() {

	unsigned long timenow;                        //a long integer to count seconds
	int valsused[8][8];                           //an 8x8 matrix to keep track of values used
	RTC.readTime();                               //get the current time

	//First display the minutes

	lc.clearDisplay(1);                           //Turn everything off
	                                              //reset the array of used values

	for (int i = 0; i < 8; i++) {
		for (int j = 0; j < 8; j++) {
			valsused[i][j] = 0;
		}
	}

	                                              //generate the right number of values and light the LEDs
	for (int count = 1; count <= RTC.m; count++) {

	generatemin:

		int col = random(8);                  //generate a random col, row
		int row = random(8);

		if (valsused[col][row] == 1) {        //if used, go back and generate again
			goto generatemin;
		}

		valsused[col][row] = 1;               //if not, mark the value as used
		lc.setLed(1, col, row, true);         // and turn on LED at col, row
	}

	//then display the hours

	lc.clearDisplay(0);                           //Turn everything off
	                                              //reset the array of used values

	for (int i = 0; i < 8; i++) {
		for (int j = 0; j < 8; j++) {
			valsused[i][j] = 0;
		}
	}

	for (int count = 1; count <= RTC.h; count++) {

	generatehr:

		int col = random(8);                 //generate a random col, row
		int row = random(8);

		if (valsused[col][row] == 1) {       //if used, go back and generate again
			goto generatehr;
		}

		valsused[col][row] = 1;              //if not, mark the value as used
		lc.setLed(0, col, row, true);        // and turn on LED at col, row
	}

	//count seconds on LED
	                                             //reset the array of used values
	for (int i = 0; i < 8; i++) {
		for (int j = 0; j < 8; j++) {
			valsused[i][j] = 0;
		}
	}

	lc.clearDisplay(2);                         //Turn everything off--00 seconds
	
	for (int secs = 0; secs < 59; secs++)       //every second
	{
		timenow = millis();                 //record the current time in millis
	
		generatesec:

		int col = random(8);                //generate a random col, row
		int row = random(8);

		if (valsused[col][row] == 1) {      //if used, go back and generate again
			goto generatesec;
		}

		valsused[col][row] = 1;             //if not, mark the value as used

		                                    //wait until a second has elapsed
		while (millis() < timenow + 1000)
		{

			delay(1);
		}
	
		lc.setLed(2, col, row, true);       // and then turn on LED at col, row


	}

}


